import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * bacteria and remove them from the blood.
 * 
 * 5.2: The white blood cell is the character we control; it can currently move up and down to catch or avoid different objects.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class WhiteCell extends Actor
{
    // private int score; Originally 5.31, removed in 5.38
    // Bloodstream bloodstream1 = (Bloodstream)getWorld(); 
    /**
     * Act: move up and down when cursor keys are pressed.
     */
    public void act() 
    {
        checkKeyPress();
        checkCollision(); // 5.13
        
        /** 5.32
         * getWorld().showText(String text, int x, int y);
         */
        
        // getWorld().showText("Score: " + score, 80, 25); Originally used in 5.33 through 5.36, removed in 5.38
    }
    
    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY() - 8); // 5.37
        }
        
        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY() + 8); // 5.37
        }
        
        // 5.29
        if (Greenfoot.isKeyDown("left")) 
        {
            setLocation(getX() - 4, getY());
        }
        
        // 5.29        
        if (Greenfoot.isKeyDown("right")) 
        {
            setLocation(getX() + 4, getY());
        }
    }
    
    // 5.13
    private void checkCollision()
    {
        // 5.14
        if(isTouching(Bacteria.class))
        {
            removeTouching(Bacteria.class);
            Greenfoot.playSound("slurp.wav"); // 5.15, 5.16
            // score = score + 20; Originally from 5.31, removed in 5.38
            
            //5.40
            Bloodstream bloodstream1 = (Bloodstream)getWorld(); // Casting
            bloodstream1.addScore(20); // 5.44
            
            // ((Bloodstream)getWorld()).addScore(int);
        }
        
        // 5.17
        if(isTouching(Virus.class))
        {
            removeTouching(Virus.class); // 5.48
            Greenfoot.playSound("slurp.wav"); // 5.49
            // Greenfoot.playSound("game-over.wav");
            // Greenfoot.stop();
            // ((Bloodstream)getWorld()).addScore(-100); 
            Bloodstream bloodstream1 = (Bloodstream)getWorld(); 
            bloodstream1.addScore(-100); // 5.48
        }

    }
    
    /** 5.4
     * void setLocation(int x, int y);
     * int getX();
     * int getY();
     */
}